﻿LWCounter = {};

local c;
_, c = UnitClass("player");
if c ~= "PRIEST" then
	LightwellCounterForm:Hide();
	LWCounter.active = false;
else
LWCounter.active = true;

LWCounterFrame = CreateFrame("FRAME", "LWCounterFrame", UIParent);
LWCounterFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
LWCounterFrame:RegisterEvent("ADDON_LOADED");
LWCounterFrame:RegisterEvent("PLAYER_REGEN_DISABLED");
LWCounterFrame:RegisterEvent("PLAYER_REGEN_ENABLED");


-- definitions

--LWCounter.addonInterface = 40200;
LWCounter.clientInterface = select(4, GetBuildInfo());

LWCounter.spellID = {};
LWCounter.spellID.Lightwell = 724;
LWCounter.spellID.LightwellRenew = 7001;
LWCounter.spellID.LightwellGlyph = 55673;

LWCounter.charges = 0;
LWCounter.total = 10;
LWCounter.timezor = 0;
LWCounter.timetotal = 180.0; -- 3 minute duration

LWCounter.filterCount=0; -- Used to control outgoing whisper filtering


-- saved vars
LWCounterConfig = {};
LWCounter.configPanel = {};

LWCounter.configPanel.postChange = function()
	if LWCounterConfig.lockPosition then LightwellCounterForm:RegisterForDrag(); else LightwellCounterForm:RegisterForDrag("LeftButton"); end
	if (LWCounterConfig.hideCombat and InCombatLockdown()==nil) or (LWCounterConfig.hideDown and LWCounter.charges==0) then LightwellCounterForm:Hide(); else LightwellCounterForm:Show(); end
end

LWCounter.configPanel.defaults = function(overwrite)
	if overwrite or LWCounterConfig.hideCombat==nil then LWCounterConfig.hideCombat = false; end
	if overwrite or LWCounterConfig.hideDown==nil then LWCounterConfig.hideDown = false; end
	if overwrite or LWCounterConfig.lockPosition==nil then LWCounterConfig.lockPosition = false; end
	if overwrite or LWCounterConfig.reportWasted==nil then LWCounterConfig.reportWasted = false; end
	if overwrite or LWCounterConfig.announceRaid==nil then LWCounterConfig.announceRaid = false; end
	if overwrite or LWCounterConfig.announceSay==nil then LWCounterConfig.announceSay = false; end
	if overwrite or LWCounterConfig.whisperUser==nil then LWCounterConfig.whisperUser = false; end
	if overwrite or LWCounterConfig.whisperUserHide==nil then LWCounterConfig.whisperUserHide = false; end
	if overwrite or LWCounterConfig.reportUses==nil then LWCounterConfig.reportUses = false; end
	
	if overwrite or LWCounterConfig.announceText==nil then LWCounterConfig.announceText = "Lightwell is up!"; end
	if overwrite or LWCounterConfig.whisperUserText==nil then LWCounterConfig.whisperUserText = "Thank you for using the Lightwell!"; end
end

LWCounter.configPanel.default = function()
	LWCounter.configPanel.defaults(true);
	LWCounter.configPanel.load();
	LWCounter.configPanel.postChange();
end

LWCounter.saveChecked = function (box, var)	if box:GetChecked()==1 then return true; else return false; end end
LWCounter.loadChecked = function (box, var)	box:SetChecked(var); end

LWCounter.configPanel.save = function()
	LWCounterConfig.hideCombat = LWCounter.saveChecked(LightwellCounterConfigHideCombat);
	LWCounterConfig.hideDown = LWCounter.saveChecked(LightwellCounterConfigHideDown);
	LWCounterConfig.lockPosition = LWCounter.saveChecked(LightwellCounterConfigLockPosition);
	LWCounterConfig.reportWasted = LWCounter.saveChecked(LightwellCounterConfigCheckWasted);
	LWCounterConfig.announceRaid = LWCounter.saveChecked(LightwellCounterConfigAnnounceRaid);
	LWCounterConfig.announceSay = LWCounter.saveChecked(LightwellCounterConfigAnnounceSay);
	LWCounterConfig.whisperUser = LWCounter.saveChecked(LightwellCounterConfigWhisperUser);
	LWCounterConfig.whisperUserHide = LWCounter.saveChecked(LightwellCounterConfigWhisperUserHide);
	LWCounterConfig.reportUses = LWCounter.saveChecked(LightwellCounterConfigReportUses);
	
	LWCounterConfig.announceText = LightwellCounterConfigAnnounceText:GetText();
	LWCounterConfig.whisperUserText = LightwellCounterConfigWhisperUserText:GetText();
	
	LWCounter.configPanel.postChange();
end

LWCounter.configPanel.load = function()
	LWCounter.loadChecked(LightwellCounterConfigHideCombat, LWCounterConfig.hideCombat);
	LWCounter.loadChecked(LightwellCounterConfigHideDown, LWCounterConfig.hideDown);
	LWCounter.loadChecked(LightwellCounterConfigLockPosition, LWCounterConfig.lockPosition);
	LWCounter.loadChecked(LightwellCounterConfigCheckWasted, LWCounterConfig.reportWasted);
	LWCounter.loadChecked(LightwellCounterConfigAnnounceRaid, LWCounterConfig.announceRaid);
	LWCounter.loadChecked(LightwellCounterConfigAnnounceSay, LWCounterConfig.announceSay);
	LWCounter.loadChecked(LightwellCounterConfigWhisperUser, LWCounterConfig.whisperUser);
	LWCounter.loadChecked(LightwellCounterConfigWhisperUserHide, LWCounterConfig.whisperUserHide);
	LWCounter.loadChecked(LightwellCounterConfigReportUses, LWCounterConfig.reportUses);
	
	LightwellCounterConfigAnnounceText:SetText(LWCounterConfig.announceText);
	LightwellCounterConfigWhisperUserText:SetText(LWCounterConfig.whisperUserText);
end

LWCounter.configPanel.OnLoad = function(panel)
	panel.name = "Lightwell Counter";
	panel:SetBackdrop(nil);
	
	panel.okay = function (self) LWCounter.configPanel.save(); end;
	panel.cancel = function (self) LWCounter.configPanel.load(); end;
	panel.default = function (self) LWCounter.configPanel.default(); end;

	--LWCounter.configPanel.thePanel = panel;
	
	InterfaceOptions_AddCategory(panel);
end


-- main functions

LWCounter.handler = function (self, event, ...)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		local timestamp, eventType, hideCaster, srcGUID, srcName, srcFlags, srcRaidFlags, dstGUID, dstName, dstFlags, destRaidFlags;
		local spellID, spellName, spellSchool, auraType;
		
		--if LWCounter.clientInterface > LWCounter.addonInterface then 
			timestamp, eventType, hideCaster, srcGUID, srcName, srcFlags, srcRaidFlage, dstGUID, dstName, dstFlags, destRaidFlags = ...;
		--else
		--	timestamp, eventType, hideCaster, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags = ...;
		--end
		
        if srcGUID==UnitGUID("player") then
            if eventType == "SPELL_SUMMON" then			
				--if LWCounter.clientInterface > LWCounter.addonInterface then
					_, _, _, _, _, _, _, _, _, _, _, spellID, spellName, spellSchool, auraType = ...;
				--else
				--	_, _, _, _, _, _, _, _, _, spellID, spellName, spellSchool, auraType = ...;
				--end
                
                if spellID==LWCounter.spellID.Lightwell then
                    local fooLightwellGlyph = false;
    
                    for i = 1, NUM_GLYPH_SLOTS do
                        local enabled, glyphType, glyphTooltipIndex, glyphSpellID, icon = GetGlyphSocketInfo(i);
                        if (glyphSpellID == LWCounter.spellID.LightwellGlyph) then fooLightwellGlyph = true; break end
                    end
                
                    if fooLightwellGlyph then LWCounter.total=15; else LWCounter.total=10; end
                    LWCounter.charges = LWCounter.total;
                    LWCounter.timezor = LWCounter.timetotal;
                    
                    LightwellCounterFormBar:SetAlpha(1);
                    LWCounter.update();
					
					local ch=nil;
					if GetNumPartyMembers()>0 then ch="PARTY"; end
					if GetNumRaidMembers()>0 then ch="RAID"; end
					
					if LWCounterConfig.announceRaid and ch~=nil then SendChatMessage(LWCounterConfig.announceText, ch); end
					if LWCounterConfig.announceSay then SendChatMessage(LWCounterConfig.announceText, "SAY"); end
					
					if not(LWCounterConfig.hideCombat) or InCombatLockdown()==1 then LightwellCounterForm:Show(); end
                end
            end
            
            if LWCounter.charges>0 then
                if eventType == "SPELL_AURA_APPLIED" then
                    --if LWCounter.clientInterface > LWCounter.addonInterface then
						_, _, _, _, _, _, _, _, _, _, _, spellID, spellName, spellSchool, auraType = ...;
					--else
					--	_, _, _, _, _, _, _, _, _, spellID, spellName, spellSchool, auraType = ...;
					--end
				
                    if spellID==LWCounter.spellID.LightwellRenew then
                        LWCounter.charges = LWCounter.charges - 1;
                        LWCounter.update();
						
						if LWCounterConfig.whisperUser and dstName~=UnitName("player") then
							LWCounter.filterCount = LWCounter.filterCount + 1;
							SendChatMessage(LWCounterConfig.whisperUserText, "WHISPER", nil, dstName);
						end
						if LWCounterConfig.reportUses then print("Lightwell: "..dstName.." used a charge ("..LWCounter.charges.." remaining)"); end
                    end
                end
                
                if eventType == "SPELL_AURA_REFRESH" then
                    --if LWCounter.clientInterface > LWCounter.addonInterface then
						_, _, _, _, _, _, _, _, _, _, _, spellID, spellName, spellSchool, auraType = ...;
					--else
					--	_, _, _, _, _, _, _, _, _, spellID, spellName, spellSchool, auraType = ...;
					--end
                    
                    if spellID==LWCounter.spellID.LightwellRenew then
                        LWCounter.charges = LWCounter.charges - 1;
                        LWCounter.update();
                        if LWCounterConfig.reportWasted then 
							if LWCounterConfig.reportUses then
								print ("Lightwell: "..dstName.." wasted a charge ("..LWCounter.charges.." remaining)");
							else
								print ("Lightwell: "..dstName.." wasted a charge");
							end
						end
                    end
                end
            end
        end
	elseif event == "PLAYER_REGEN_DISABLED" then
		if not(LWCounterConfig.hideDown) or LWCounter.charges~=0 then LightwellCounterForm:Show(); end
	elseif event == "PLAYER_REGEN_ENABLED" then
		if LWCounterConfig.hideCombat then LightwellCounterForm:Hide(); end
	elseif event == "ADDON_LOADED" then
		local addonName = ...;
		
		if addonName=="LightwellCounter" then
			LWCounter.configPanel.defaults(false);
		
			LWCounter.configPanel.load();
			LWCounter.configPanel.postChange();
			LightwellCounterConfigAnnounceText:SetAutoFocus(false);
			LightwellCounterConfigWhisperUserText:SetAutoFocus(false);
		end
	end
end

LWCounter.update = function ()
    local tehtext;

    LightwellCounterFormBar:SetValue(LWCounter.charges / LWCounter.total);

    if LWCounter.charges>0 then
        if LWCounter.charges == 1 then
            tehtext = "1 charge";
        else
            tehtext = LWCounter.charges.." charges"
        end  
    else
        tehtext = "No lightwell up";
		if LWCounterConfig.hideDown then LightwellCounterForm:Hide(); end
    end
    
    LightwellCounterFormChargesLabel:SetText (tehtext);
end

LWCounter.onUpdate = function (self, elapsed)
    if LWCounter.timezor > 0 then
        LWCounter.timezor = LWCounter.timezor - elapsed;
    
        if LWCounter.timezor > 0 then
            -- do colour
            local val = LWCounter.timezor / LWCounter.timetotal;
            val = 0.5 + 0.5*val;
            LightwellCounterFormBar:SetStatusBarColor(val, val, 0, 1);
            
            -- do pulsing
            if (LWCounter.timezor < 10.5) then
                LightwellCounterFormBar:SetAlpha(math.abs(math.sin(math.pi*LWCounter.timezor)));
            end
        else
            -- must have timed out
            LWCounter.charges = 0;
            LWCounter.update();
        end
    end
end

LWCounter.handleClick = function (self, button)
	if button == "RightButton" then InterfaceOptionsFrame_OpenToCategory("Lightwell Counter"); end
end

LWCounter.filter = function(_, event, msg)
	if LWCounter.filterCount>0 then
		LWCounter.filterCount = LWCounter.filterCount - 1;	
		if LWCounterConfig.whisperUserHide and msg:match(LWCounterConfig.whisperUserText) then return true; end
	end
end


-- init
LWCounterFrame:SetScript("OnEvent", LWCounter.handler);
LWCounterFrame:SetScript("OnUpdate", LWCounter.onUpdate);

LWCounter.update();

ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", LWCounter.filter);

end
